@import "../variables.less";

.tor2e.sheet.actor {

  h2 {
    color: #800000;
  }

  .hostile-friendly {
    display: flex;

    .hf-slider {
      width: 150px;
    }
  }

  .section {
    text-align: center;
    justify-content: center;
    align-content: center;
    align-items: center;

    h4 {
      font-weight: bold;
      font-size: @large;
      text-align: center;
      flex: none;
    }

    .active-effect {
      margin: 0 0.1em;
      flex: none;
      text-align: center;
      justify-content: center;
      align-content: center;
      align-items: center;
      cursor: pointer;

      img {
        opacity: 0.1;
        width: 30px;
        height: 30px;
        text-align: center;
        flex: none;
        background-color: black;
      }

      img.active {
        opacity: 1;
      }

      .label {
        text-align: center;
        font-size: @small;
        flex: none;
      }

      .active-effect-header {
        flex: none;
        justify-content: end;
        align-items: center;
        align-content: center;
      }

      .active-effect-value {
        flex: none;
        justify-content: center;
        align-items: center;
        align-content: center;
        width: 2.5em;
        align-self: end;

        input, label {
          flex: none;
        }

        label {
          margin: 0.5em 0;
        }
      }
    }

  }

  .section.main-section {
    flex: 3;

    .active-effect-row {
      justify-content: space-evenly;
      background: rgba(0, 0, 0, 0.05);
      padding: 10px 5px 5px 5px;
    }
  }

  .section.secondary-section {
    flex: 1;
  }

  .three-states-checkbox {
    cursor: pointer;

    p {
      font-size: @bigger;
    }

    .empty-square::before {
      font-size: @xlarge;
      background: rgba(0, 0, 0, 0.1);
      border-radius: 50%;
      border: none;
      font-family: "Font Awesome 5 Free", serif;
      font-weight: 400;
      content: "\f111";
    }

    .check-square::before {
      font-size: @xlarge;
      background: rgba(0, 0, 0, 0.1);
      border-radius: 50%;
      border: none;
      font-family: "Font Awesome 5 Free", serif;
      font-weight: 400;
      content: "\f058";
    }

    .times-square::before {
      font-size: @xlarge;
      background: rgba(0, 0, 0, 0.1);
      border-radius: 50%;
      border: none;
      font-family: "Font Awesome 5 Free", serif;
      font-weight: 400;
      content: "\f057";
    }

  }

  input[type="checkbox"] {
    flex: 0 0 20px;
    width: auto;
    height: auto;
    margin: 0.1em;
  }

  .attribute-label {
    flex: none;
    margin-right: 0.5em;
    margin-bottom: 0.1em;
  }

  .attribute-number-value {
    flex: none;
    width: 4em;
    text-align: center;
    margin-right: 0.5em;
  }

  .attribute-text-value {
    flex: none;
    text-align: left;
  }

  form {
    display: flex;
    flex-direction: column;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    border: none;
    margin: auto;
    position: absolute;
  }

  img.actor-banner {
    flex: 0;
    width: auto;
    object-fit: cover;
    object-position: 100% 65%;
    border: none;
  }

  img.member-token {
    flex: 0;
    width: auto;
    object-fit: cover;
    object-position: 100% 65%;
    border: none;
  }

  .list-actor {
    justify-content: center;
    align-content: center;
    align-items: center;

    .member-name {
      align-items: center;
      align-content: center;

      p {
        flex: none;
        text-overflow: ellipsis;
        white-space: nowrap;
        max-width: 7em;
        display: inline-block;
        overflow: hidden;
      }

      .actions {
        flex: 0;
        min-width: fit-content;
      }
    }
  }

  .sheet-header {

    img {
      flex: 0 0 125px;
      width: 125px;
      height: 125px;
      object-fit: contain;
      object-position: 50% 0;
      border: 5px double darkgray;
      background: lightgray;
      padding: 2px 0;
    }

  }

  .sheet-content {
    display: flex;
    flex-direction: column;
    justify-content: space-evenly;

    #health {

      .section:first-of-type {
        padding-right: 1em;
      }

    }

    .sidebar {
      text-align: center;
      margin-bottom: 0.5em;
      flex: 1.1;

      .complex-stat-container {
        justify-content: space-evenly;

        .main-stat {
          flex: none;
        }
      }
    }

    .central {
      flex: 4.5;

      .attributes {
        justify-content: space-around;
      }

    }

    .complex-stat {
      justify-content: center;
    }

    .main-stat {
      align-items: center;
      align-content: center;
      justify-content: space-evenly;
      flex: 1;

      .skill-name {
        flex: none;
        margin-bottom: 0.25em;
      }

      label, .label {
        font-weight: bold;
        font-size: @large;
        margin-bottom: 0.25em;
        margin-top: 0;
        flex: none;

        a {
          font-size: initial;
        }
      }

      .main-stat-value {
        position: relative;
        align-items: center;
        flex: none;

        .main-stat-label {
          position: absolute;
          left: -1.5em;
          top: 1.5em;
          color: @tor2e-red;
        }
      }


      .main-stat-value.warn {
        background: radial-gradient(circle, rgba(236, 6, 12, 0) 25%, rgba(246, 3, 15, 1) 75%, rgba(255, 0, 18, 0) 100%) !important;
      }

      .computed > .main-stat-value {
        background: @computed-background-colour;
        flex: none;
      }

      .item-name:hover {
        .action {
          visibility: visible;
        }
      }

      .item-name {
        position: absolute;
        left: -5em;
        top: -1em;
        font-size: 0.75em;
        font-weight: initial;
        text-align: left;
        align-items: center;
        width: 6em;
        max-width: 90px;
        display: inline-block;
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
        color: @tor2e-red;

        p {
          margin-left: 0.25em;
          white-space: break-spaces;
        }

        img {
          border: none;
        }

        .action {
          flex: none;
          visibility: hidden;
        }
      }

      .input-stat-wrapper, .item-value {
        width: 1.75em;
        height: 1.75em;
        text-align: center;
        border: 4px double @tor2e-red;
        background: @input-background-colour;
        padding: 0;
        font-size: @large;
        box-sizing: content-box;
        min-width: unset;
        transform: rotate(45deg);
        color: @tor2e-red;
        margin: 0.25em 0 0;
        flex: none;

        input, .input-stat-value {
          font-size: @normal;
          align-items: center;
          transform: rotate(-45deg);
          background: rgba(0, 0, 0, 0);
          border: 0;
          border-radius: 0;
          padding: 0;
          text-align: center;
          color: @tor2e-red;
          width: 100%;
          height: 100%;
          margin: auto;
          justify-content: center;
          display: flex;
        }
      }

      .item-value {
        background: @computed-background-colour;
      }

      .secondary-stat, .secondary-item {
        label {
          position: absolute;
          font-size: @small;
          font-weight: initial;
          text-align: left;
          width: 10em;
          margin-top: 0;
          left: 2.1em;
          top: -2.5em;
          transform: rotate(-45deg);

          p {
            max-width: 8em;
            display: inline-block;
            margin-top: 0;
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
          }
        }

        .item-name {
          transform: rotate(0deg);
          left: 6em;
          color: @tor2e-red;
          top: -1em;
          position: absolute;
          font-size: @small;
          font-weight: initial;
          text-align: left;
          width: 10em;
          margin-top: 0;

          p {
            max-width: 8em;
            display: inline-block;
            margin-top: 0;
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
          }
        }

        .input-stat-wrapper, .item-value {
          position: absolute;
          right: -1.9em;
          top: -0.65em;
          background: @input-background-colour repeat;
          text-align: center;
          border: 2px solid @tor2e-red;
          padding: 0;
          font-size: @small;
          box-sizing: content-box;
          flex: none;
          color: @tor2e-red;

          input, .input-stat-value {
            font-size: @normal;
            align-items: center;
            transform: rotate(-45deg);
            background: rgba(0, 0, 0, 0);
            border: 0;
            border-radius: 0;
            padding: 0;
            text-align: center;
            color: @tor2e-red;
            margin: auto;
            width: 100%;
            height: 100%;
            justify-content: center;
            display: flex;
          }
        }

        .item-value {
          background: @computed-background-colour;
        }

        .stat-name {
          position: absolute;
          left: 5.5em;
          top: 2.25em;
          font-size: @small;
          font-weight: initial;
          min-width: fit-content;
          text-align: left;
          width: 10em;
          margin-top: 0;
        }

        .stat-value {
          width: 1.5em;
          height: 1.5em;
          margin: 0;
          position: absolute;
          right: -1.5em;
          top: -0.5em;
          background: @input-background-colour;
          text-align: center;
          border-radius: 50%;
          border: solid black;
          padding: 0.15em;
          font-size: initial;
          box-sizing: content-box;

          p {
            background: @computed-background-colour;
          }
        }
      }

      .tertiary-stat {

        label {
          position: absolute;
          right: -9.5em;
          top: -3.5em;
          font-size: @small;
          font-weight: initial;
          min-width: fit-content;
          text-align: left;
          width: 10em;
          transform: rotate(-45deg);
        }

        .input-stat-wrapper, .item-value {
          position: absolute;
          right: -2em;
          bottom: -.75em;
          background: @input-background-colour repeat;
          text-align: center;
          border: 2px solid @tor2e-red;
          padding: 0;
          font-size: @small;
          box-sizing: content-box;
          flex: none;
          color: @tor2e-red;

          input, .input-stat-value {
            font-size: @normal;
            align-items: center;
            transform: rotate(-45deg);
            background: rgba(0, 0, 0, 0);
            border: 0;
            border-radius: 0;
            padding: 0;
            text-align: center;
            color: @tor2e-red;
            margin: auto;
            width: 100%;
            height: 100%;
            justify-content: center;
            display: flex;
          }
        }
      }
    }

    .main-stat.simple {
      flex: 0.9
    }

    .main-stat.extended {
      flex: 1.25
    }

    .stat-row {
      display: flex;
      align-items: center;
      justify-content: space-around;
      margin-bottom: 0.5em;
    }

    .stat {
      align-items: center;

      label {
        font-size: @large;
      }

      .skill-label {
        font-size: @normal;
      }

      input {
        text-align: center;
        width: 4em;
      }

      div {
        display: flex;
        justify-content: center;
        align-items: center;

        label {
          font-size: @small;
        }
      }

      .sibling {

        margin-left: 0.1em;

        label {
          text-transform: lowercase;
          font-size: @small;
        }

        input[type=checkbox] {
          width: auto;
        }
      }
    }

    label.favoured {
      display: inline;
      text-transform: lowercase;
      font-size: @small;

      input[type="checkbox"] {
        width: auto;
        height: auto;
      }
    }

    .dice {
      align-self: center;
      width: 100%;
      height: 100%;
      margin: 0;
      padding: 0;
      display: flex;
      align-items: center;
      justify-content: center;
    }

    .dice::after {
      content: "D";
    }

    .bonus {
      align-self: center;
    }

    .bonus::before {
      content: "+";
    }

    .attribute-table-value {
      position: relative;
      justify-content: center;
      text-align: center;

      .secondary-stat {
        position: absolute;
        right: 2.5em;
      }

      label {
        text-align: center;
        margin-right: 0.2em;

        input {
          text-align: center;
          width: 4em;
        }
      }

      .item-value {
        padding: 0.5em;
        border: 1px solid black;
        width: fit-content;
        margin: 0;
      }

      .main {
        text-align: center;
        margin-right: 0.2em;
      }

      .accessory {
        text-align: center;
        margin-left: 0.2em;
      }
    }

  }

  .lore {

    .hostile-friendly {
      .hf-slider {
        width: 200px;

        .slider.round {
          width: 50px;
        }
      }
    }

    .sheet-content {

      .item-row {
        flex: 2;
        align-items: center;

        .attribute-label {
          font-weight: bold;
        }

      }

    }

  }

  .state-of-health-sidebar {
    align-items: flex-end;
    display: flex;

    .state-of-health-item {
      align-items: center;
    }
  }

  .flexrow > h2, .flexcol > h2 {
    flex: 0;
  }

  #armours {
    flex: 1.9;
  }

  .state-of-health {
    margin-top: 2em;
    text-align: center;
  }

  .skill-container {
    justify-content: space-around;

    .skill-column {
      flex: none;
    }
  }

  .item-data {
    text-align: center;
    align-items: center;

    .identification {
      text-align: left;

      p {
        flex: none;
        margin-left: 0.2em;
      }

      img {
        border: none;
      }
    }

    .attribute-container {
      display: flex;
      justify-content: center;
    }

    .skill-value {
      justify-content: center;
      align-items: center;

      .checkbox {
        flex: none;
      }
    }

    .attribute-value {
      flex: none;
      width: 3em;
    }
  }

  .table-caption {
    font-weight: bold;
    text-align: center;
  }

  .table-main-column {
    flex: 3;
  }

  .table-complex-column {
    flex: 2;
  }

  .attribute-value {
    text-align: center;
  }

  .item-description {
    h3 {
      margin: 0;
      font-weight: bold;
      background: rgba(0, 0, 0, 0.05);
    }
  }

  .simple-stat-row {
    justify-content: space-around;
    align-items: center;
  }

  .double-biography-element {
    flex: 2;
    margin-left: 0.25em;
    margin-bottom: 0.25em;
  }

  .biography-element {
    margin-left: 0.25em;
    margin-bottom: 0.25em;
  }

  .common-skill-column {
    margin-left: 0.1em;
    margin-right: 0.1em;
  }

  .common-skill-column:not(:last-child) {
    border-right: 3px double @tor2e-red;
  }

  .pips-value {
    margin-bottom: 0.25em;
    margin-right: 0;
  }

  .skill-element-row {
    cursor: pointer;
    justify-content: center;

    > * {
      font-size: @normal;
      width: @skill-diamond-size;
      height: @skill-diamond-size;
      transform: rotate(45deg);
      border: 1.5px solid @tor2e-red;
      margin: 0 0.1em;
      flex: none;
    }

    .skill-display-element-full {
      background-color: @tor2e-red;
    }
  }

  .skill-element-row.inactive {
    cursor: initial;

    > * {
      border: 1.5px solid @tor2e-red-disabled;
    }

    .skill-display-element-full {
      background-color: @tor2e-red-disabled;
    }

    .skill-display-element {
      visibility: hidden;
    }
  }

  .skillBonus-element-row {
    cursor: initial;
    justify-content: center;

    > * {
      font-size: @normal;
      width: @skillBonus-diamond-size;
      height: @skillBonus-diamond-size;
      transform: rotate(45deg);
      border: 1.5px solid @tor2e-green;
      margin: 0 0.1em;
      flex: none;
    }

    .skill-display-element-full {
      background-color: @tor2e-green;
    }

    .skill-display-element {
      visibility: hidden;
    }
  }

  .skillBonus-element-row.inactive {
    cursor: initial;

    > * {
      border: 1.5px solid @tor2e-green-disabled;
    }

    .skill-display-element-full {
      background-color: @tor2e-green-disabled;
    }

    .skill-display-element {
      visibility: hidden;
    }
  }

  .rollable {
    a > * {
      cursor: pointer;
    }
  }

  .character-actor-drop {
    border-style: inset;
    min-height: 50px;
    background: rgba(0, 0, 0, 0.1);
  }

  .actor-emblem {
    min-height: 50px;
    margin: 0.05em;
    width: 120px;
    flex: none;

    .list-actor {
      flex: none;
    }

    .actor-wrapper {
      background: rgba(0, 0, 0, 0.1);
      margin: 0.5em;
      padding-top: 0.5em;
      border: 1px solid #777;
      box-shadow: 3px 3px 5px 0 rgba(3, 3, 3, 0.5);
      -webkit-box-shadow: 3px 3px 5px 0 rgba(3, 3, 3, 0.5);
      -moz-box-shadow: 3px 3px 5px 0 rgba(3, 3, 3, 0.5);
      align-items: center;
      height: 140px;

      .token-wrapper {
        flex: none
      }
    }
  }

  #unassigned-members {
    .actor-drop {
      width: 100%;
      border-style: inset;
      background: rgba(0, 0, 0, 0.1);
    }
  }

  #travel-roles {
    .actor-drop {
      border-style: inset;
      min-height: 50px;
      background: rgba(0, 0, 0, 0.1);
    }

  }

  .role-label + .actor-drop {
    margin-right: 0.1em;
    margin-left: 0.1em;
    justify-content: center;
    align-content: center;
    align-items: center;
    display: flex;
    flex-direction: column;
  }

  .role-label {
    margin-right: 0.5em;
    flex: none;
    text-align: center;

    .label {
      font-weight: bold;
      font-size: @bigger;
      margin-bottom: 0;
    }

    .skill {
      margin-top: 0;
      font-style: italic;
    }
  }

  .actor-row {
    justify-content: space-around;
    background: rgba(0, 0, 0, 0.1);
  }

  .big-row {
    margin-bottom: 2em;
  }

  .primary-section {
    flex: 2.2;
  }

  .secondary-section {
    flex: 1.6;
  }

  .primary-block {
    flex: 2.5;
  }

  .secondary-block {
    flex: 1.25;
  }

  .section-elements {
    justify-content: space-evenly;
    align-content: space-evenly;
    align-items: center;
    display: flex;
    flex-direction: column;

    .main-stat {
      padding-bottom: 0.75em;
    }
  }

  .rest-actions {
    justify-content: space-evenly;
    background: rgba(0, 0, 0, 0.05);
    padding: 10px 5px 0 5px;

    .rest-action {
      text-align: center;
      flex: none;
      width: 3.5em;
      align-items: center;

      img {
        border: none;
        width: 30px;
      }

      a {
        flex: none;
        width: 30px;
        height: 30px;

        i {
          font-size: 2em;
        }
      }

      p {
        flex: none;
        padding: 0;
        font-size: @small;
      }
    }
  }

  .tor2e-round-checkbox {
    position: relative;

    p {
      min-height: 0.5rem;
      margin-top: 0;
    }

    .label {
      background-color: #c7b798;
      border: 1px solid #a19989;
      border-radius: 50%;
      cursor: pointer;
      height: 1.5em;
      left: 0;
      position: absolute;
      top: 0;
      width: 1.5em;
    }

    .label:after {
      border: 2px solid #fff;
      border-top: none;
      border-right: none;
      content: "";
      height: 0.2em;
      left: 3px;
      opacity: 0;
      position: absolute;
      top: 2px;
      transform: rotate(-45deg);
      width: 100%;
    }

    .active {
      > .label {
        background-color: #7f6623;
        border-color: #3B2F0FFF;
      }

      > .label:after {
        opacity: 1;
      }
    }

  }

  .tor2e-round-checkbox.big-check-box {

    .label:after {
      height: 0.4em;
      width: 0.7em;
    }

  }

  .activable-item {
    opacity: 0.4;
  }

  .dropped {
    opacity: 0.15;
  }

  .equipped {
    opacity: 1;
  }

}

.tor2e.sheet.actor.character, .tor2e.sheet.actor.community  {
  .table-layout{
    padding-inline-start: 0;
    background: rgba(0, 0, 0, 0.05);
    margin-right: 0.2em;
    padding: 0.2em;
    flex: none;
  }

  #standings {
    .item.standing {
      padding-bottom: 0.1em;

      img {
        border: none;
        flex: none;
        margin-right: 0.2em;
        margin-left: 0.1em;
      }

      img + p {
        text-align: left;
      }
    }
  }
}

